package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

public class TestInstructor {

    @Test
    public void testImplementation(){
        Instructor instructor = new Instructor(1,"jim");

        Assert.assertTrue(instructor instanceof Teacher);
    }

    @Test
    public void testInheritance(){
        Instructor instructor = new Instructor(1, "Jim");

        Assert.assertTrue(instructor instanceof Person);
    }

    @Test
    public void testTeach(){
        Instructor instructor = new Instructor(1, "jim");
        Student student = new Student(2,"bob");
        double totalStudyTIme = 9;
        double numberOfHours = 9;

        instructor.teach(student,numberOfHours);

        Assert.assertTrue(totalStudyTIme == numberOfHours);


    }

    @Test
    public void testLecture(){
        Instructor instructor = new Instructor(1,"Jim");
        Learner[] learners = new Learner[0];
        double numberOfHours = 21;
        double totalStudyTime= 21;
        double numberOfHoursPerLearner = numberOfHours/learners.length;

        instructor.lecture(learners, numberOfHours);

        Assert.assertEquals(numberOfHours/learners.length, numberOfHoursPerLearner, 0.0001);
    }

}
